com.fasterxml.jackson.databind

## Class JsonSerializer<T>

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>

All Implemented Interfaces:
  JsonFormatVisitable

Direct Known Subclasses:
  JsonSerializer.None, StdSerializer, TypeWrappedSerializer

    public abstract class JsonSerializer<T>
    extends Object
    implements JsonFormatVisitable

Abstract class that defines API used by `ObjectMapper` (and other chained `JsonSerializer`s too) to serialize Objects of arbitrary types into JSON, using provided `JsonGenerator`.

NOTE: it is recommended that custom serializers extend `StdSerializer` instead of this class, since it will implement many of optional methods of this class.

If serializer is an aggregate one -- meaning it delegates handling of some of its contents by using other serializer(s) -- it typically also needs to implement `ResolvableSerializer`, which can locate secondary serializers needed. This is important to allow dynamic overrides of serializers; separate call interface is needed to separate resolution of secondary serializers (which may have cyclic link back to serializer itself, directly or indirectly).

In addition, to support per-property annotations (to configure aspects of serialization on per-property basis), serializers may want to implement `ContextualSerializer`, which allows specialization of serializers: call to `ContextualSerializer.createContextual(com.fasterxml.jackson.databind.SerializerProvider, com.fasterxml.jackson.databind.BeanProperty)` is passed information on property, and can create a newly configured serializer for handling that particular property.

If both `ResolvableSerializer` and `ContextualSerializer` are implemented, resolution of serializers occurs before contextualization.

### Nested Class Summary

Nested Classes
`static class` `JsonSerializer.None` This marker class is only to be used with annotations, to indicate that no serializer is configured.

### Constructor Summary

Constructors
Constructor and Description
`JsonSerializer()`

### Method Summary

Methods
`void` `acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor, JavaType type)` Default implementation simply calls `JsonFormatVisitorWrapper.expectAnyFormat(JavaType)`.
`JsonSerializer<?>` `getDelegatee()` Accessor that can be used to determine if this serializer uses another serializer for actual serialization, by delegating calls.
`Class<T>` `handledType()` Method for accessing type of Objects this serializer can handle.
`boolean` `isEmpty(T value)` Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).
`boolean` `isUnwrappingSerializer()` Accessor for checking whether this serializer is an "unwrapping" serializer; this is necessary to know since it may also require caller to suppress writing of the leading property name.
`JsonSerializer<T>` `replaceDelegatee(JsonSerializer<?> delegatee)` Method that can be called to try to replace serializer this serializer delegates calls to.
`abstract void` `serialize(T value, JsonGenerator jgen, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
`void` `serializeWithType(T value, JsonGenerator jgen, SerializerProvider provider, TypeSerializer typeSer)` Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.
`JsonSerializer<T>` `unwrappingSerializer(NameTransformer unwrapper)` Method that will return serializer instance that produces "unwrapped" serialization, if applicable for type being serialized (which is the case for some serializers that produce JSON Objects as output).
`boolean` `usesObjectId()` Method that can be called to see whether this serializer instance will use Object Id to handle cyclic references.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### JsonSerializer

    public JsonSerializer()

### Method Detail

#### unwrappingSerializer

    public JsonSerializer<T> unwrappingSerializer(NameTransformer unwrapper)

Method that will return serializer instance that produces "unwrapped" serialization, if applicable for type being serialized (which is the case for some serializers that produce JSON Objects as output). If no unwrapped serializer can be constructed, will simply return serializer as-is.

Default implementation just returns serializer as-is, indicating that no unwrapped variant exists

Parameters:
  `unwrapper` - Name transformation to use to convert between names of unwrapper properties

#### replaceDelegatee

    public JsonSerializer<T> replaceDelegatee(JsonSerializer<?> delegatee)

Method that can be called to try to replace serializer this serializer delegates calls to. If not supported (either this serializer does not delegate anything; or it does not want any changes), should either throw `UnsupportedOperationException` (if operation does not make sense or is not allowed); or return this serializer as is.

Since:
  2.1

#### serialize

    public abstract void serialize(T value,
                 JsonGenerator jgen,
                 SerializerProvider provider)
                            throws IOException,
                                   JsonProcessingException

Method that can be called to ask implementation to serialize values of type this serializer handles.

Parameters:
  `value` - Value to serialize; can not be null.
  `jgen` - Generator used to output resulting Json content
  `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
Throws:
  `IOException`
  `JsonProcessingException`

#### serializeWithType

    public void serializeWithType(T value,
                         JsonGenerator jgen,
                         SerializerProvider provider,
                         TypeSerializer typeSer)
                           throws IOException,
                                  JsonProcessingException

Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.

Default implementation will throw `UnsupportedOperationException` to indicate that proper type handling needs to be implemented.

For simple datatypes written as a single scalar value (JSON String, Number, Boolean), implementation would look like:

      // note: method to call depends on whether this type is serialized as JSON scalar, object or Array!
      typeSer.writeTypePrefixForScalar(value, jgen);
      serialize(value, jgen, provider);
      typeSer.writeTypeSuffixForScalar(value, jgen);

and implementations for type serialized as JSON Arrays or Objects would differ slightly, as `START-ARRAY>/`END-ARRAY` and `START-OBJECT>/`END-OBJECT` pairs need to be properly handled with respect to serializing of contents.``

Parameters:
  `value` - Value to serialize; can not be null.
  `jgen` - Generator used to output resulting Json content
  `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
  `typeSer` - Type serializer to use for including type information
Throws:
  `IOException`
  `JsonProcessingException`

#### handledType

    public Class<T> handledType()

Method for accessing type of Objects this serializer can handle. Note that this information is not guaranteed to be exact -- it may be a more generic (super-type) -- but it should not be incorrect (return a non-related type).

Default implementation will return null, which essentially means same as returning `Object.class` would; that is, that nothing is known about handled type.

#### isEmpty

    public boolean isEmpty(T value)

Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).

Default implementation will consider only null values to be empty.

Since:
  2.0

#### usesObjectId

    public boolean usesObjectId()

Method that can be called to see whether this serializer instance will use Object Id to handle cyclic references.

#### isUnwrappingSerializer

    public boolean isUnwrappingSerializer()

Accessor for checking whether this serializer is an "unwrapping" serializer; this is necessary to know since it may also require caller to suppress writing of the leading property name.

#### getDelegatee

    public JsonSerializer<?> getDelegatee()

Accessor that can be used to determine if this serializer uses another serializer for actual serialization, by delegating calls. If so, will return immediate delegate (which itself may delegate to further serializers); otherwise will return null.

Returns:
  Serializer this serializer delegates calls to, if null; null otherwise.
Since:
  2.1

#### acceptJsonFormatVisitor

    public void acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor,
                               JavaType type)
                                 throws JsonMappingException

Default implementation simply calls `JsonFormatVisitorWrapper.expectAnyFormat(JavaType)`.

Specified by:
  `acceptJsonFormatVisitor` in interface `JsonFormatVisitable`
  `type` - Type of element (entity like property) being visited
Throws:
  `JsonMappingException`
Since:
  2.1